(require 'determinant)

(define nn 11)
(define L (matrix:create nn nn 0))

(define (L_1 i j) (if (and (= i 0) (= j 1)) 0 0))
(define (L_2 i j) (if (and (= i (1- nn)) (= j (- nn 2))) 0 0))
(define (L_3 i j) 
	(if (and (= i (- j 1)) (>= i 1) (<= i (- nn 2)) (>= j 2) (<= j (1- nn))) 110 0))
(define (L_4 i j)
	(if (and (= i (+ j 1)) (>= i 1) (<= i (- nn 2)) (>= j 0) (<= j (- nn 3))) 90 0))
(define (L_5 i j)
	(if (and (= i j) (>= i 0) (<= i (1- nn)) (>= j 0) (<= j (1- nn))) -210 0))

(define tstart (current-time))
(define L (matrix:sum L (matrix:create nn nn L_1)))
(define L (matrix:sum L (matrix:create nn nn L_2)))
(define L (matrix:sum L (matrix:create nn nn L_3)))
(define L (matrix:sum L (matrix:create nn nn L_4)))
(define L (matrix:sum L (matrix:create nn nn L_5)))
(matrix:set! L 0 0 1)
(matrix:set! L 10 10 1)
(display (- (current-time) tstart))

(define a 0)
(define b 1)
(define N 10)

(define h (/ (- b a) N))

(define x (matrix:create nn 1 (lambda (i j) (+ a (* h i)))))
(define rhs (matrix:create nn 1 (lambda (i j) (+ (* 7 (exp (* -1 (matrix:ref x i j)))) 4))))
(matrix:set! rhs 0 0 2)
(matrix:set! rhs 10 0 -5)

(define PLU (matrix:plu-factor L))
(define x_b (matrix:forward-substitute (cadr PLU) (matrix:permute-rows rhs (car PLU))))
(define y (matrix:back-substitute (cddr PLU) x_b))
